Index: trunk/source/processes/hadronic/cross_sections/src/G4PiData.cc
===================================================================
--- trunk/source/processes/hadronic/cross_sections/src/G4PiData.cc	(revision 1007)
+++ trunk/source/processes/hadronic/cross_sections/src/G4PiData.cc	(revision 1055)
@@ -24,5 +24,5 @@
 // ********************************************************************
 //
-// GEANT4 tag $Name: geant4-09-02 $
+// GEANT4 tag $Name: geant4-09-03-beta-cand-01 $
 //
 // --------------------------------------------------------------------
Index: trunk/source/processes/hadronic/cross_sections/src/G4TripathiCrossSection.cc
===================================================================
--- trunk/source/processes/hadronic/cross_sections/src/G4TripathiCrossSection.cc	(revision 1007)
+++ trunk/source/processes/hadronic/cross_sections/src/G4TripathiCrossSection.cc	(revision 1055)
@@ -39,5 +39,5 @@
                 G4double /*temperature*/) 
 {
-  G4double result = 0;
+  G4double result = 0.;
   
   const G4double targetAtomicNumber = AA;
@@ -60,5 +60,5 @@
   pTarget = pTarget+pProjectile;
   G4double E_cm = (pTarget.mag()-targetMass-pProjectile.m())/MeV;
-  
+  if(E_cm <= DBL_MIN) return result;  
   // done
   G4double r_rms_p = 0.6 * myNuleonRadius * 
@@ -78,5 +78,5 @@
   //done
   G4double B = 1.44*nProjProtons*nTargetProtons/Radius;
-  
+  if(E_cm <= B) return result; 
   // done
   G4double Energy = kineticEnergy/projectileAtomicNumber;
@@ -133,5 +133,5 @@
                  (1-B/E_cm);
   
-  if(result < 0) result = 0;
+  if(result < 0.) result = 0.;
   return result*m2;
 
Index: trunk/source/processes/hadronic/cross_sections/src/G4TripathiLightCrossSection.cc
===================================================================
--- trunk/source/processes/hadronic/cross_sections/src/G4TripathiLightCrossSection.cc	(revision 1007)
+++ trunk/source/processes/hadronic/cross_sections/src/G4TripathiLightCrossSection.cc	(revision 1055)
@@ -153,4 +153,7 @@
   pT = pT + pP;
   G4double E_cm = (pT.mag()-mT-pP.m())/MeV;
+  if(E_cm <= DBL_MIN) return result;  
+
+
 //
 //
@@ -169,5 +172,6 @@
 
   G4double B = 1.44 * ZP * ZT / Radius;
-//
+  if(E_cm <= B) return result; 
+
 //
 // Now determine other parameters associated with the parametric
@@ -289,6 +293,5 @@
   if (!lowEnergyCheck)
   {
-    if (result < 0.0)
-      result = 0.0;
+    if (result < 0.0)  result = 0.0;
     else if (E < 6.0*MeV)
     {
Index: trunk/source/processes/hadronic/cross_sections/src/G4VCrossSectionDataSet.cc
===================================================================
--- trunk/source/processes/hadronic/cross_sections/src/G4VCrossSectionDataSet.cc	(revision 1007)
+++ trunk/source/processes/hadronic/cross_sections/src/G4VCrossSectionDataSet.cc	(revision 1055)
@@ -24,8 +24,33 @@
 // ********************************************************************
 //
-// $Id: G4VCrossSectionDataSet.cc,v 1.7 2006/12/29 02:05:48 dennis Exp $
-// 
+// $Id: G4VCrossSectionDataSet.cc,v 1.8 2009/01/24 11:54:47 vnivanch Exp $
+// GEANT4 tag $Name: geant4-09-03-beta-cand-01 $
+//
+// -------------------------------------------------------------------
+//
+// GEANT4 Class file
+//
+//
+// File name:    G4VCrossSectionDataSet
+//
+// Author  F.W. Jones, TRIUMF, 20-JAN-97
+//
+// Modifications:
+// 23.01.2009 V.Ivanchenko move constructor and destructor to source
+//
 
 #include "G4VCrossSectionDataSet.hh"
+#include "G4CrossSectionDataSetRegistry.hh"
+
+G4VCrossSectionDataSet::G4VCrossSectionDataSet() :
+  verboseLevel(0)
+{
+  G4CrossSectionDataSetRegistry::Instance()->Register(this);
+}
+
+G4VCrossSectionDataSet::~G4VCrossSectionDataSet()
+{
+  G4CrossSectionDataSetRegistry::Instance()->DeRegister(this);
+}
 
 // Override this method to test for particle and isotope applicability
Index: trunk/source/processes/hadronic/management/History
===================================================================
--- trunk/source/processes/hadronic/management/History	(revision 1007)
+++ trunk/source/processes/hadronic/management/History	(revision 1055)
@@ -14,4 +14,23 @@
      * Please list in reverse chronological order (last date on top)
      ---------------------------------------------------------------
+
+25 February 2009 Vladimir Ivanchenko (hadr-man-V09-02-04)
+---------------------------------------------------------
+- G4HadronicProcessStore - added protection to the Clean method 
+
+22 February 2009 Vladimir Ivanchenko (hadr-man-V09-02-03)
+---------------------------------------------------------
+
+14 February 2009 Vladimir Ivanchenko (hadr-man-V09-02-02)
+---------------------------------------------------------
+- G4HadronicProcessStore - added Clean method and cleanup of model 
+                           and cross section stores
+
+06 February 2009 Vladimir Ivanchenko (hadr-man-V09-02-01)
+---------------------------------------------------------
+
+24 January 2009 Vladimir Ivanchenko (hadr-man-V09-02-00)
+-------------------------------------------------------
+- G4HadronicProcessStore - added destruction of processes
 
 01 December 2008 Dennis Wright (hadr-man-V09-01-10)
Index: trunk/source/processes/hadronic/management/include/G4HadronicProcessStore.hh
===================================================================
--- trunk/source/processes/hadronic/management/include/G4HadronicProcessStore.hh	(revision 1007)
+++ trunk/source/processes/hadronic/management/include/G4HadronicProcessStore.hh	(revision 1055)
@@ -24,6 +24,6 @@
 // ********************************************************************
 //
-// $Id: G4HadronicProcessStore.hh,v 1.3 2008/10/22 07:58:20 vnivanch Exp $
-// GEANT4 tag $Name: geant4-09-02 $
+// $Id: G4HadronicProcessStore.hh,v 1.5 2009/02/15 16:50:15 vnivanch Exp $
+// GEANT4 tag $Name: geant4-09-03-beta-cand-01 $
 //
 //
@@ -72,4 +72,6 @@
   ~G4HadronicProcessStore();
 
+  void Clean();
+
   G4double GetInelasticCrossSectionPerVolume(
     const G4ParticleDefinition *aParticle,
Index: trunk/source/processes/hadronic/management/src/G4HadronicProcessStore.cc
===================================================================
--- trunk/source/processes/hadronic/management/src/G4HadronicProcessStore.cc	(revision 1007)
+++ trunk/source/processes/hadronic/management/src/G4HadronicProcessStore.cc	(revision 1055)
@@ -24,6 +24,6 @@
 // ********************************************************************
 //
-// $Id: G4HadronicProcessStore.cc,v 1.7 2008/10/22 07:58:20 vnivanch Exp $
-// GEANT4 tag $Name: geant4-09-02 $
+// $Id: G4HadronicProcessStore.cc,v 1.12 2009/02/25 16:29:03 vnivanch Exp $
+// GEANT4 tag $Name: geant4-09-03-beta-cand-01 $
 //
 // -------------------------------------------------------------------
@@ -39,7 +39,9 @@
 //
 // Modifications:
-//
+// 23.01.2009 V.Ivanchenko add destruction of processes
 //
 // Class Description:
+// Singleton to store hadronic processes, to provide access to processes
+// and to printout information about processes
 //
 // -------------------------------------------------------------------
@@ -53,4 +55,6 @@
 #include "G4Electron.hh"
 #include "G4Proton.hh"
+#include "G4HadronicInteractionRegistry.hh"
+#include "G4CrossSectionDataSetRegistry.hh"
 
 G4HadronicProcessStore* G4HadronicProcessStore::theInstance = 0;
@@ -71,9 +75,40 @@
 G4HadronicProcessStore::~G4HadronicProcessStore()
 {
-  /*
-  for (G4int i=0; i<n_proc; i++) {
-    if( process[i] ) delete process[i];
-  }
-  */
+  Clean();
+  G4HadronicInteractionRegistry::Instance()->Clean();
+  G4CrossSectionDataSetRegistry::Instance()->Clean();
+}
+
+//....oooOO0OOooo........oooOO0OOooo........oooOO0OOooo........oooOO0OOooo.....
+
+void G4HadronicProcessStore::Clean()
+{
+  G4int i;
+  //G4cout << "G4HadronicProcessStore::Clean() Nproc= " << n_proc
+  //	 << "  Nextra= " << n_extra << G4endl;
+  if(n_proc > 0) {
+    for (i=0; i<n_proc; i++) {
+      if( process[i] ) {
+        //G4cout << "G4HadronicProcessStore::Clean() delete hadronic " << i << G4endl;
+	//G4cout <<  process[i]->GetProcessName() << G4endl;
+	delete process[i];
+	process[i] = 0;
+      }
+    }
+  }
+  if(n_extra > 0) {
+    for(i=0; i<n_extra; i++) {
+      if(extraProcess[i]) {
+        //G4cout << "G4HadronicProcessStore::Clean() delete extra "  
+	//       << i << G4endl;
+	//G4cout << extraProcess[i]->GetProcessName() << G4endl;
+	delete extraProcess[i];
+        extraProcess[i] = 0;
+      }
+    }
+  }
+  //G4cout << "G4HadronicProcessStore::Clean() done" << G4endl; 
+  n_extra = 0;
+  n_proc = 0;
 }
 
@@ -325,6 +360,11 @@
 void G4HadronicProcessStore::Register(G4HadronicProcess* proc) 
 { 
-  for(G4int i=0; i<n_proc; i++) {if(process[i] == proc) return;}
-    
+  if(0 < n_proc) {
+    for(G4int i=0; i<n_proc; i++) {
+      if(process[i] == proc) return;
+    }
+  }
+  //G4cout << "G4HadronicProcessStore::Register hadronic " << n_proc
+  //	 << "  " << proc->GetProcessName() << G4endl;
   n_proc++;
   process.push_back(proc);
@@ -384,8 +424,9 @@
 void G4HadronicProcessStore::DeRegister(G4HadronicProcess* proc)
 {
+  if(0 == n_proc) return;
   for(G4int i=0; i<n_proc; i++) {
     if(process[i] == proc) {
       process[i] = 0;
-      break;
+      return;
     }
   }
@@ -396,5 +437,11 @@
 void G4HadronicProcessStore::RegisterExtraProcess(G4VProcess* proc)
 {
-  for(G4int i=0; i<n_extra; i++) {if(extraProcess[i] == proc) return;}
+  if(0 < n_extra) {
+    for(G4int i=0; i<n_extra; i++) {
+      if(extraProcess[i] == proc) return;
+    }
+  }
+  //G4cout << "Extra Process: " << n_extra << "  " <<  proc->GetProcessName() 
+  //	 << "  " << proc << G4endl;
     
   n_extra++;
@@ -437,8 +484,11 @@
 void G4HadronicProcessStore::DeRegisterExtraProcess(G4VProcess* proc)
 {
+  //G4cout << "Deregister Extra Process: " << proc << "   " << proc->GetProcessName() << G4endl;
+  if(0 == n_extra) return;
   for(G4int i=0; i<n_extra; i++) {
     if(extraProcess[i] == proc) {
       extraProcess[i] = 0;
-      break;
+      //G4cout << "Extra Process: " << i << " is deregisted " << G4endl;
+      return;
     }
   }
Index: trunk/source/processes/hadronic/models/cascade/History
===================================================================
--- trunk/source/processes/hadronic/models/cascade/History	(revision 1007)
+++ trunk/source/processes/hadronic/models/cascade/History	(revision 1055)
@@ -14,4 +14,23 @@
      * Please list in reverse chronological order (last date on top)
      ---------------------------------------------------------------
+
+15 Apr 2009 Dennis Wright (hadr-casc-V09-02-02)
+-----------------------------------------------
+- previous tag no longer used.  Bring hadr-casc-V09-02-00 back to
+  HEAD and re-tag
+
+21 Feb 2009 Dennis Wright (hadr-casc-V09-02-01)
+-----------------------------------------------
+- add printCrossSection method to G4CascadSpecialFunctions
+- in GeElementaryParticleCollider, add high energy flag to distinguish
+  "string-like" behavior
+- G4IntraNucleiCascader.cc - allow secondaries from HE interaction to 
+  leave nucleus without interacting
+- G4NucleiModel - get high_energy_interaction flag value from G4ElementaryParticleCollider
+
+11 Feb 2009 V.Ivanchenko (hadr-casc-V09-02-00)
+-----------------------------------------------
+- set absorption coefficient 1.0 instead of 0.2 inside
+  G4CascadSpecialFunctions (D.Wright)
 
 25 Nov 2008 Dennis Wright (hadr-casc-V09-01-10)
Index: trunk/source/processes/hadronic/models/cascade/cascade/src/G4CascadSpecialFunctions.cc
===================================================================
--- trunk/source/processes/hadronic/models/cascade/cascade/src/G4CascadSpecialFunctions.cc	(revision 1007)
+++ trunk/source/processes/hadronic/models/cascade/cascade/src/G4CascadSpecialFunctions.cc	(revision 1055)
@@ -113,5 +113,6 @@
   }
 
-  const G4double corr_fac = 0.2;
+  // was 0.2 since the beginning 
+  const G4double corr_fac = 1.0;
   G4double csec = 0.0;
   
Index: trunk/source/processes/hadronic/models/chiral_inv_phase_space/body/History
===================================================================
--- trunk/source/processes/hadronic/models/chiral_inv_phase_space/body/History	(revision 1007)
+++ trunk/source/processes/hadronic/models/chiral_inv_phase_space/body/History	(revision 1055)
@@ -4,37 +4,38 @@
        ==========================================================
 
-        History file for hadronic/models/chiral_inv_phase_space/interface 
+History file for  hadronic/models/chiral_inv_phase_space/body  directory.
 	
-This file should be used to summarize modifications introduced in the 
-code and to keep track of all tags.
+Summarize all code modifications & keep track of all tags in this file.
 
-     ---------------------------------------------------------------
-     * Please list in reverse chronological order (last date on top)
-     ---------------------------------------------------------------
+****************************************************************************
+*** Geant4 developers can not make changes in this directory or make the ***
+*** History records without permision of M.Kosov: Mikhail.Kossov@cern.ch ***
+****************************************************************************
 
-31-Mar-2008 Dennis Wright               (hadr-chips-body-V09-01-04)
--------------------------------------------------------------------
-- add more parentheses around && within || to satisfy gcc-4.3 compiler
-  files affected:
-    G4QChipolino.cc
-    G4QEnvironment.cc
-    G4QNucleus.cc
-    G4Quasmon.cc
+     -----------------------------------------------------------------
+     * Please list in reverse chronological order (last date on top) *
+     -----------------------------------------------------------------
 
-19-Mar-2008 Dennis Wright               (hadr-chips-body-V09-01-03)
--------------------------------------------------------------------
-- add parentheses around && within || to satisfy gcc-4.3 compiler
-  files affected:
-    G4QChipolino.cc
-    G4QContent.cc
-    G4QEnvironment.cc
-    G4QNucleus.cc
-    G4QPDGCode.cc
-    G4Quasmon.cc
 
-- add braces and ; for empty while blocks to satisfy gcc-4.3
-  files affected:
-    G4QHadron.cc
+26-May-2009 M.Kosov                              (hadr-chips-body-V09-02-06)
+----------------------------------------------------------------------------
+Safety check of nDelta in the hadronization probability calculations (G4Quasmon)
+to avoid /zero
 
-18-Mar-2008 Vladimir Ivanchenko         (hadr-chips-body-V09-01-02)
-- G4QNucleus - fixed compillation warnings at Windows for constructors
+26-May-2009 M.Kosov                              (hadr-chips-body-V09-02-05)
+----------------------------------------------------------------------------
+In low energy nHe and pHe reactions, when only elastic scattering is possible,
+the inelastic application makes a complain, while it is making the elastic
+scattering (with very low cross-section). *** The complain is closed ***
+
+15-May-2009 M.Kosov                              (hadr-chips-body-V09-02-04)
+----------------------------------------------------------------------------
+For rare cases of the output hadron mass below the GS mass instead of Exception
+in the G4QEnvironment class a fill As Is for the hadron is used with appropriate
+warning. If this case can be reproduced, it should be debugged in future.
+
+29-Apr-2009 M.Kosov                              (hadr-chips-body-V09-02-03)
+----------------------------------------------------------------------------
+The rare situation was Found by Alberto. It is improved in G4QEnvironment.
+When the Hypernucleus can not decay in the residual nucleus and pion, then
+now it is decayed in the residual nucleus and gamma. 
Index: trunk/source/processes/hadronic/models/chiral_inv_phase_space/body/include/G4QBesIKJY.hh
===================================================================
--- trunk/source/processes/hadronic/models/chiral_inv_phase_space/body/include/G4QBesIKJY.hh	(revision 1007)
+++ trunk/source/processes/hadronic/models/chiral_inv_phase_space/body/include/G4QBesIKJY.hh	(revision 1055)
@@ -25,6 +25,6 @@
 //
 //
-// $Id: G4QBesIKJY.hh,v 1.2 2006/06/29 20:05:55 gunter Exp $
-// GEANT4 tag $Name: geant4-09-02 $
+// $Id: G4QBesIKJY.hh,v 1.3 2009/02/23 09:49:24 mkossov Exp $
+// GEANT4 tag $Name: geant4-09-03-beta-cand-01 $
 //
 //      ---------------- G4QBesIKJY ----------------
@@ -32,5 +32,7 @@
 //  class header for Bessel I0/I1 and K0/K1 functions in CHIPS Model
 // --------------------------------------------------------------------
-
+// Short description: CHIPS bessel functions for mass and scattering
+// integrals.
+// --------------------------------------------------------------------
 #ifndef G4QBesIKJY_h
 #define G4QBesIKJY_h 1
Index: trunk/source/processes/hadronic/models/chiral_inv_phase_space/body/include/G4QCHIPSWorld.hh
===================================================================
--- trunk/source/processes/hadronic/models/chiral_inv_phase_space/body/include/G4QCHIPSWorld.hh	(revision 1007)
+++ trunk/source/processes/hadronic/models/chiral_inv_phase_space/body/include/G4QCHIPSWorld.hh	(revision 1055)
@@ -25,6 +25,6 @@
 //
 //
-// $Id: G4QCHIPSWorld.hh,v 1.25 2006/06/29 20:05:57 gunter Exp $
-// GEANT4 tag $Name: geant4-09-02 $
+// $Id: G4QCHIPSWorld.hh,v 1.26 2009/02/23 09:49:24 mkossov Exp $
+// GEANT4 tag $Name: geant4-09-03-beta-cand-01 $
 //
 //      ---------------- G4QCHIPSWorld ----------------
@@ -32,4 +32,17 @@
 //  class header for CHIPS World of particles in CHIPS Model
 // ------------------------------------------------------------
+// Short description: The CHIPS World is a world of elementary particles
+// and nuclear fragments. This class is a singletone, but without fixed
+// limits. E.g. the nuclear fragments as possible G4Candidates can be
+// initialized in the CHIPS World only up to Be8 od C12 or other bigger
+// nuclear fragment. If one need the heavy fragment production then the
+// the CHIPS World must be initialized up to these fragments (see the
+// CHIPS Manual), but the price in performans will be big, because in
+// each act of the fragmentation competition these numerous candidates
+// take place in the competition and the hadronization probability is
+// calculated each time for each of them, so the Be8 limit (Be8->alpha+
+// alpha decays very fast and contribute to the alpha-spectrum) is the
+// most optimal.
+// -------------------------------------------------------------------
 
 #ifndef G4QCHIPSWorld_h
Index: trunk/source/processes/hadronic/models/chiral_inv_phase_space/body/include/G4QCandidate.hh
===================================================================
--- trunk/source/processes/hadronic/models/chiral_inv_phase_space/body/include/G4QCandidate.hh	(revision 1007)
+++ trunk/source/processes/hadronic/models/chiral_inv_phase_space/body/include/G4QCandidate.hh	(revision 1055)
@@ -25,6 +25,6 @@
 //
 //
-// $Id: G4QCandidate.hh,v 1.28 2006/06/29 20:05:59 gunter Exp $
-// GEANT4 tag $Name: geant4-09-02 $
+// $Id: G4QCandidate.hh,v 1.29 2009/02/23 09:49:24 mkossov Exp $
+// GEANT4 tag $Name: geant4-09-03-beta-cand-01 $
 //
 //      ---------------- G4QCandidate ----------------
@@ -32,4 +32,8 @@
 //  class header for Quasmon initiated Candidates used by the CHIPS Model
 // ----------------------------------------------------------------------
+// Short description: A candidate for hadronization. The candidates
+// (hadrons or nuclear fragments) are competative, each quark of a
+// Quasmon select which candidate to use for hadronization
+// ------------------------------------------------------------------
 
 #ifndef G4QCandidate_h
@@ -81,5 +85,5 @@
   void SetNBMass(G4double newMass);         // Set mass bounded to Total Nucleus
 
-// Body  								   
+// Body             
 private:
   G4bool   possible;                // permission/forbiding preFlag to be a hadron/fragment
Index: trunk/source/processes/hadronic/models/chiral_inv_phase_space/body/include/G4QCandidateVector.hh
===================================================================
--- trunk/source/processes/hadronic/models/chiral_inv_phase_space/body/include/G4QCandidateVector.hh	(revision 1007)
+++ trunk/source/processes/hadronic/models/chiral_inv_phase_space/body/include/G4QCandidateVector.hh	(revision 1055)
@@ -25,6 +25,6 @@
 //
 //
-// $Id: G4QCandidateVector.hh,v 1.21 2006/06/29 20:06:01 gunter Exp $
-// GEANT4 tag $Name: geant4-09-02 $
+// $Id: G4QCandidateVector.hh,v 1.22 2009/02/23 09:49:24 mkossov Exp $
+// GEANT4 tag $Name: geant4-09-03-beta-cand-01 $
 //
 //      ---------------- G4QCandidateVector ----------------
@@ -32,4 +32,8 @@
 // Type defenition for Quasmon initiated Candidates used by CHIPS model
 // -----------------------------------------------------------------
+// Short description: A candidate for hadronization. The candidates
+// (hadrons or nuclear fragments) are competative, each quark of a
+// Quasmon select which candidate to use for hadronization
+// ------------------------------------------------------------------
 
 #ifndef G4QCandidateVector_h
Index: trunk/source/processes/hadronic/models/chiral_inv_phase_space/body/include/G4QChipolino.hh
===================================================================
--- trunk/source/processes/hadronic/models/chiral_inv_phase_space/body/include/G4QChipolino.hh	(revision 1007)
+++ trunk/source/processes/hadronic/models/chiral_inv_phase_space/body/include/G4QChipolino.hh	(revision 1055)
@@ -25,6 +25,6 @@
 //
 //
-// $Id: G4QChipolino.hh,v 1.23 2006/06/29 20:06:03 gunter Exp $
-// GEANT4 tag $Name: geant4-09-02 $
+// $Id: G4QChipolino.hh,v 1.24 2009/02/23 09:49:24 mkossov Exp $
+// GEANT4 tag $Name: geant4-09-03-beta-cand-01 $
 //
 //      ---------------- G4QChipolino ----------------
@@ -32,4 +32,10 @@
 //  class header for Chipolino (Double Hadron) in CHIPS Model
 // ----------------------------------------------------------
+// Short description: In the CHIPS model not only hadrons are considered,
+// but the di-hadrons, which can not be convereged to the quark content
+// of only one hadron (e.g. pi+pi+, K+p, Delta++p etc). This kind of
+// hadronic states, which can be easily decayed in two hadrons, is called
+// Chipolino-particle in the model.
+// ---------------------------------------------------------------------- 
 
 #ifndef G4QChipolino_h
@@ -56,5 +62,5 @@
 
   // Selectors
-  G4double              GetMass();            // Get mass of the Chipolino (MinDoubleHadronMass)
+  G4double              GetMass();            // Get ChipolinoMass (MinDoubleHadronMass)
   G4double              GetMass2();           // Get mass^2 of the Chipolino
   G4QPDGCode            GetQPDG1();           // Get 1-st QPDG of the Chipolino
@@ -66,12 +72,12 @@
   // Modifiers
   void SetHadronQPDG(const G4QPDGCode& QPDG); // Set QPDG of 1-st Hadron of the Chipolino
-  void SetHadronPDGCode(const G4int& PDGCode);// Set PDGCode of 1-st Hadron of the Chipolino
-  void SetHadronQCont(const G4QContent& QC);  // Set QContent of 1-st Hadron of the Chipolino
+  void SetHadronPDGCode(const G4int& PDGCode);// Set PDGCode of 1st Hadron of the Chipolino
+  void SetHadronQCont(const G4QContent& QC);  // Set QContent of 1st Hadron of theChipolino
 
 private:  
   G4QPDGCode            theQPDG1;             // QPDG of the 1-st Hadron of the Chipolino
   G4QPDGCode            theQPDG2;             // QPDG of the 2-nd Hadron of the Chipolino
-  G4QContent            theQCont;             // Quark Content of the whole Chipolino
-  G4QContent            theQCont1;            // Quark Content of the 1-st Hadron of Chipolino
+  G4QContent            theQCont;             // QuarkContent of the whole Chipolino
+  G4QContent            theQCont1;            // QuarkCont. of the 1st Hadron of Chipolino
   G4double              minM;                 // Minimal Mass of Chipolino
 };
Index: trunk/source/processes/hadronic/models/chiral_inv_phase_space/body/include/G4QContent.hh
===================================================================
--- trunk/source/processes/hadronic/models/chiral_inv_phase_space/body/include/G4QContent.hh	(revision 1007)
+++ trunk/source/processes/hadronic/models/chiral_inv_phase_space/body/include/G4QContent.hh	(revision 1055)
@@ -25,6 +25,6 @@
 //
 //
-// $Id: G4QContent.hh,v 1.28 2006/06/29 20:06:05 gunter Exp $
-// GEANT4 tag $Name: geant4-09-02 $
+// $Id: G4QContent.hh,v 1.29 2009/02/23 09:49:24 mkossov Exp $
+// GEANT4 tag $Name: geant4-09-03-beta-cand-01 $
 //
 //      ---------------- G4QContent ----------------
@@ -32,4 +32,14 @@
 //  class header for Quasmon initiated Contents used by the CHIPS Model
 // ----------------------------------------------------------------------
+// Short description: This is the basic class of the CHIPS model. It
+// describes the quark content of the Quasmon, which is a generalized
+// hadronic state. All Quasmons are bags, characterized by the quark
+// Content (QContent), but the spin is not fixed and only light (u,d,s)
+// quarks are considered (SU(3)). The hadrons are the ground states for
+// the corresponding quasmons. The Chipolino (G4QChipolino) or nuclear
+// cluster are examples for another Quark Content.
+// --------------------------------------------------------------------
+// @@ In future total spin & c,b,t of the Hadron can be added @@ M.K.@@
+// --------------------------------------------------------------------
 
 #ifndef G4QContent_h
Index: trunk/source/processes/hadronic/models/chiral_inv_phase_space/body/include/G4QDecayChan.hh
===================================================================
--- trunk/source/processes/hadronic/models/chiral_inv_phase_space/body/include/G4QDecayChan.hh	(revision 1007)
+++ trunk/source/processes/hadronic/models/chiral_inv_phase_space/body/include/G4QDecayChan.hh	(revision 1055)
@@ -25,6 +25,6 @@
 //
 //
-// $Id: G4QDecayChan.hh,v 1.23 2006/06/29 20:06:07 gunter Exp $
-// GEANT4 tag $Name: geant4-09-02 $
+// $Id: G4QDecayChan.hh,v 1.24 2009/02/23 09:49:24 mkossov Exp $
+// GEANT4 tag $Name: geant4-09-03-beta-cand-01 $
 //
 //      ---------------- G4QDecayChan ----------------
@@ -32,4 +32,11 @@
 //  class header for Decay Channel definition in CHIPS Model
 // ------------------------------------------------------------
+// Short description: In the CHIPS World the particles (G4QParticle)
+// are defined. For unstable particles there is a G4QDecayChannelVector
+// which describes different channels of decay for the particular
+// particle. So the G4QDecayChannel class is the class for the description
+// of such a decay channel in two or three particles (the secondaries can
+// be unstable too and have firther decay).
+// -------------------------------------------------------------------
 
 #ifndef G4QDecayChan_h
Index: trunk/source/processes/hadronic/models/chiral_inv_phase_space/body/include/G4QDecayChanVector.hh
===================================================================
--- trunk/source/processes/hadronic/models/chiral_inv_phase_space/body/include/G4QDecayChanVector.hh	(revision 1007)
+++ trunk/source/processes/hadronic/models/chiral_inv_phase_space/body/include/G4QDecayChanVector.hh	(revision 1055)
@@ -25,6 +25,6 @@
 //
 //
-// $Id: G4QDecayChanVector.hh,v 1.19 2006/06/29 20:06:09 gunter Exp $
-// GEANT4 tag $Name: geant4-09-02 $
+// $Id: G4QDecayChanVector.hh,v 1.20 2009/02/23 09:49:24 mkossov Exp $
+// GEANT4 tag $Name: geant4-09-03-beta-cand-01 $
 //
 //      ---------------- G4QCandidateVector ----------------
@@ -32,4 +32,11 @@
 // Type defenition for Decay Channel Vector in CHIPS model
 // --------------------------------------------------------------
+// Short description: In the CHIPS World the particles (G4QParticle)
+// are defined. For unstable particles there is a G4QDecayChannelVector
+// which describes different channels of decay for the particular
+// particle. So the G4QDecayChannel class is the class for the description
+// of such a decay channel in two or three particles (the secondaries can
+// be unstable too and have firther decay).
+// -------------------------------------------------------------------
 
 #ifndef G4QDecayChanVector_h
Index: trunk/source/processes/hadronic/models/chiral_inv_phase_space/body/include/G4QEnvironment.hh
===================================================================
--- trunk/source/processes/hadronic/models/chiral_inv_phase_space/body/include/G4QEnvironment.hh	(revision 1007)
+++ trunk/source/processes/hadronic/models/chiral_inv_phase_space/body/include/G4QEnvironment.hh	(revision 1055)
@@ -25,6 +25,6 @@
 //
 //
-// $Id: G4QEnvironment.hh,v 1.32 2007/10/07 13:31:41 mkossov Exp $
-// GEANT4 tag $Name: geant4-09-02 $
+// $Id: G4QEnvironment.hh,v 1.33 2009/02/23 09:49:24 mkossov Exp $
+// GEANT4 tag $Name: geant4-09-03-beta-cand-01 $
 //
 //      ---------------- G4QEnvironment ----------------
@@ -32,4 +32,12 @@
 //      header for Multy Quasmon Environment in the CHIPS Model
 // ------------------------------------------------------------
+// Short description: The G4QEnvironment class corresponds to the nuclear
+// environment,  containing excited nucleons or nuclear clusters
+// (G4Quasmons). In the constructer the nucleus (G4QNucleus) is clusterized
+// and then the projectile hadron (or hadrons) can create one (or a few)
+// Quasmons, which are fragmented by the Fragment member function. As a
+// result a vector of G4QHadrons is created, which can include the residual
+// nucleus in the ground state.
+//---------------------------------------------------------------------
 
 #ifndef G4QEnvironment_h
@@ -82,4 +90,5 @@
   void             EvaporateResidual(G4QHadron* h);// Final Evaporation of a nucl. fragment
   void             DecayBaryon(G4QHadron* dB);     // Decay baryon (gamma+N or Delta->N+Pi)
+  void             DecayAntistrange(G4QHadron* aS);// Decay Antistrange nucleus
   G4bool           CheckGroundState(G4Quasmon* quasm,G4bool corFlag=false);//as G4Q for QHV
   G4bool           DecayInEnvQ(G4Quasmon* quasm);  // Use befor evaporation in PANIC case
Index: trunk/source/processes/hadronic/models/chiral_inv_phase_space/body/include/G4QException.hh
===================================================================
--- trunk/source/processes/hadronic/models/chiral_inv_phase_space/body/include/G4QException.hh	(revision 1007)
+++ trunk/source/processes/hadronic/models/chiral_inv_phase_space/body/include/G4QException.hh	(revision 1055)
@@ -25,6 +25,6 @@
 //
 //
-// $Id: G4QException.hh,v 1.10 2006/06/29 20:06:13 gunter Exp $
-// GEANT4 tag $Name: geant4-09-02 $
+// $Id: G4QException.hh,v 1.11 2009/02/23 09:49:24 mkossov Exp $
+// GEANT4 tag $Name: geant4-09-03-beta-cand-01 $
 //
 //      ---------------- G4QException ----------------
@@ -32,4 +32,6 @@
 //  header of the class for an Exception used by the CHIPS Model
 // ---------------------------------------------------------------
+// Short description: Just an internal CHIPS Exception Messenger
+// -------------------------------------------------------------
 
 #ifndef G4QException_h
